/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * Some simple Tempura programs.  
 * Ben Moszkowski 
 */

/* run */ define test1() =
  exists I,J: { input(I) and J=0 and box output(J) and halt(I=0)
        and (I gets I-1) and (J gets J+I)}.

/* run */ define test2() =
  exists M,N: { input (M) and N=1 and box output (N) and
        while not (M=0) do {skip and M:=M-1 and N:=2*N}}.

/* run */ define test3() =
  exists I: { {skip;skip;skip} and I=0 and box output(I) and I gets I+1}.




/*  Versions of the above for inclusion in exercise file */

define linear_test(n) =
  exists I,J: { I=n and J=0 and  box output(J) and halt(I=0)
        and (I gets I-1) and (J gets J+I)}.

define while_test(i) =
  exists M,N: { M=i and N=1 and box output (N) and
        while not (M=0) do {skip and M:=M-1 and N:=2*N}}.

define skip_test() =
  exists I: { {skip;skip;skip} and I=0 and box output(I) and I gets I+1}.

